package jp.marunomaruno.judeapi2cpp;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.text.DateFormat;
import java.util.Date;
import java.util.HashSet;
import java.util.Set;

import com.change_vision.jude.api.inf.exception.ProjectLockedException;
import com.change_vision.jude.api.inf.model.IAttribute;
import com.change_vision.jude.api.inf.model.IClass;
import com.change_vision.jude.api.inf.model.IConstraint;
import com.change_vision.jude.api.inf.model.IElement;
import com.change_vision.jude.api.inf.model.IGeneralization;
import com.change_vision.jude.api.inf.model.IModel;
import com.change_vision.jude.api.inf.model.INamedElement;
import com.change_vision.jude.api.inf.model.IOperation;
import com.change_vision.jude.api.inf.model.IPackage;
import com.change_vision.jude.api.inf.model.IParameter;
import com.change_vision.jude.api.inf.model.ITaggedValue;
import com.change_vision.jude.api.inf.project.ProjectAccessor;
import com.change_vision.jude.api.inf.project.ProjectAccessorFactory;

/**
 * Jude ̃vWFNg̏񂩂AΉCPPt@CAwb_[t@CAMAKEt@C܂B
 * 
 * @author maruno
 * @version 1.0, 2007-12-20
 * @since 1.0
 */
public class JudeApi2Cpp {

	/**
	 * ̓t@CB
	 */
	@SuppressWarnings("unused")
	private File source;

	/**
	 * o̓fBNgB
	 */
	private File destination;

	/**
	 * ^[QbgƂȂvOB
	 */
	private String target;

	/**
	 * ̃vWFNgŎgpĂNX
	 */
	private Set<IClass> classes = new HashSet<IClass>();

	/**
	 * ̃CX^X𐶐ftHgRXgN^[łB
	 */
	public JudeApi2Cpp() {
	}

	/**
	 * JudevWFNgCPP̃\[XAwb_[AMAKEFILEɕϊ܂B
	 * 
	 * @param source
	 *            Judẽt@C
	 * @param destination
	 *            ϊ̃t@Ci[fBNg[
	 * @param target ^[QbgƂȂvO
	 * @throws ProjectLockedException
	 * @throws Exception
	 * @see com.change_vision.jude.api.inf.exception.ProjectLockedException
	 */
	public void execute(File source, File destination, String target)
			throws ProjectLockedException, Exception {
		this.source = source;
		this.destination = destination;
		this.target = target;
		
		// vpeB\
		JudeApi2CppUtil.println("----------------------------------------");
		JudeApi2CppUtil.println("PROPERTIES");
		JudeApi2CppUtil.printProperties();
		JudeApi2CppUtil.println("----------------------------------------");

		// vWFNgJāAvWFNgf擾
		ProjectAccessor prjAccessor = ProjectAccessorFactory
				.getProjectAccessor();
		try {
			prjAccessor.open(source.getPath());
		} catch (ProjectLockedException e) {
			throw e;
		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(1);
		}
		IModel iModel = prjAccessor.getProject();
		JudeApi2CppUtil.print(iModel, "project");
		JudeApi2CppUtil.println("----------------------------------------");

		// NX̏W
		setClassInfometion(iModel.getOwnedElements());

		// NXt@Co͂B
		for (IClass c : classes) {
			JudeApi2CppUtil.print(c);
			createClassHeaderFile(c); // wb_[t@C
			createClassCppFile(c); // cppt@C
		}

		// maket@Co͂B
		createMakefile(classes);
		
		// IbZ[W
		System.out.println("ϊI܂B");
	}

	/**
	 * vWFNg̖OtvfċAIɕ\܂B A擪 "java"  "javax" Ŏn܂pbP[W͏܂B
	 * 
	 * @param iNamedElements
	 */
	private void setClassInfometion(INamedElement[] iNamedElements) {
		for (INamedElement element : iNamedElements) {
			if (element.getName().equals("java")) continue;
			if (element.getName().equals("javax")) continue;

			// *&Ă̂́A^Ƃēo^Ȃ(̂̌^͕ʂɒ`Ă)
			if (element.getName().indexOf('*') >= 0)
				continue;
			if (element.getName().indexOf('&') >= 0)
				continue;
			if (element.getName().indexOf('<') >= 0)
				continue;

			if (element instanceof IClass && isExcepted((IClass) element)) {
				classes.add((IClass) element);
			}

			if (element instanceof IPackage) {
				setClassInfometion(((IPackage) element).getOwnedElements());
			}
		}

	}

	/**
	 * w肳ꂽNXAO^ǂ𔻒肵܂B
	 * 
	 * @param element
	 *            NX^
	 * @return O^Ȃtrue
	 */
	private boolean isExcepted(IClass element) {
		return !JudeApi2CppProperty.getInstance().getExceptTypes()
				.contains(element.getName());
	}

	/**
	 * makefile쐬܂B
	 * 
	 * @param classes
	 *            NX̃Zbg
	 * @throws IOException 
	 */
	private void createMakefile(Set<IClass> classes) throws IOException {
		if (classes.size() == 0)
			return;

		PrintWriter out = createFile("Makefile");
		if (out == null) {
			return;
		}

		try {
			BufferedReader in = new BufferedReader(new FileReader(
					JudeApi2CppProperty.getInstance().getMakefileSekeleton()));

			// t@C̃Rg
			out.println("# ");
			out.println("# " + "Makefile");
			out.println("# " + "create date: "
					+ DateFormat.getDateInstance().format(new Date()));
			out.println("# ");

			String line;

			// OBJS̑O܂
			while ((line = in.readLine()) != null) {
				line = line.replaceFirst("@\\(target\\)", target);
				if (line.startsWith("OBJS"))
					break;
				out.println(line);
			}

			// OBJS ̓WJ
			out.print(line);
			for (IClass c : classes) {
				if (!c.getName().equalsIgnoreCase(target)) {
					out.print(" \\\n\t" + c.getName() + "."
							+ JudeApi2CppProperty.getInstance().getObjectSuffix());
				}
			}
			out.println();

			// cŌ܂
			while ((line = in.readLine()) != null) {
				out.println(line);
			}

			in.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		out.close();

	}

	/**
	 * NX̃wb_[t@C𐶐܂B
	 * 
	 * @param iClass
	 * @throws IOException 
	 */
	private void createClassHeaderFile(IClass iClass) throws IOException {
		String name = getParseTypeName(iClass);
		String headerMacroName = name.toUpperCase() + "_H_";
		PrintWriter out = createFile(name + ".h");
		if (out == null) {
			return;
		}

		// CN[hK[h
		out.println("#ifndef " + headerMacroName);
		out.println("#define " + headerMacroName);

		// t@C̃Rg
		out.println("/*");
		out.println(" * " + name + ".h");
		out.println(" * " + "create date: "
				+ DateFormat.getDateInstance().format(new Date()));
		out.println(" */");

		// w肳ꂽ^̃CN[h
		for (String type : JudeApi2CppProperty.getInstance().getDefaultIncludeTypes()) {
			out.println("#include <" + type + ">");
		}

		// gpĂ^̃CN[h
		Set<String> types = getParseTypeNames(iClass);
		for (String type : types) {
			if (type.equals(name)) {
				continue;
			}
			out.println("#include \"" + type + ".h\"");
		}

		// NX錾͂
		// Rg
		out.println();
		printElementComment(out, "", iClass);
		
		out.print("class " + name);

		IGeneralization[] generalizations = iClass.getGeneralizations();
		if (generalizations.length != 0) {
			out.print(" : ");
			boolean first = true;
			for (IGeneralization g : generalizations) {
				// J}
				if (!first) {
					out.print(", ");
				}

				// z{NX
				if (isVirtual(g)) {
					out.print(" virtual ");
				}

				// {NX̃ANZX
				out.print(" " + getVisibilityString(g) + " ");

				// {NX
				out.print(g.getSuperType().getName());

				first = false;
			}
		}
		out.print(" {");
		out.println();

		// o[ϐ̐錾
		String indent = "    ";

		for (IAttribute attribute : iClass.getAttributes()) {

			// TODO
			// Us\̑̓XLbv
			// if (!attribute.isEnable()) continue;
			if (attribute.getName() == null || attribute.getName().isEmpty())
				continue;

			// Rg
			out.println();
			printElementComment(out, indent, attribute);

			out.println(JudeApi2CppUtil.getVisibility(attribute) + ": ");

			out.print(indent);

			// ÓI
			if (attribute.isStatic()) {
				out.print("static ");
			}

			// 萔
			if (!attribute.isChangeable()) {
				out.print("const ");
			}

			// mutable
			if (isMutable(attribute)) {
				out.print("mutable ");
			}

			// ^
//			out.print(attribute.getTypeExpression() + " ");
			out.print(JudeApi2CppUtil.getFullName(attribute.getType()) + " ");

			// ϐ
			out.print(attribute.getName());

			// dx
			if (JudeApi2CppUtil.isMultiplicity(attribute)) {
				out.print("[]");
			}

			// static const ̂Ƃ̏l
			if (attribute.isStatic() && !attribute.isChangeable()) {
				out.print(" = " + attribute.getInitialValue());
			}

			out.println(";");

		}

		// o[֐̐錾
		for (IOperation operation : iClass.getOperations()) {

			//@Rg
			out.println();
			printElementComment(out, indent, operation);

			out.println(JudeApi2CppUtil.getVisibility(operation) + ": ");

			out.print(indent);

			// ÓI
			if (operation.isStatic()) {
				out.print("static ");
			}

			// ()z֐
			if (operation.isAbstract() || isVirtual(operation)) {
				out.print("virtual ");
			}

			// friend
			if (isFriend(operation)) {
				out.print("friend ");
			}

			// explicit֐
			if (isExplicit(operation)) {
				out.print(" explicit ");
			}
			// ߂ľ^
//			out.print(operation.getReturnTypeExpression() + " ");
			out.print(JudeApi2CppUtil.getFullName(operation.getReturnType()) + " ");

			// ֐
			out.print(operation.getName());
			out.print("(");

			// 
			if (operation.getParameters().length > 0) {
				boolean first = true;
				for (IParameter parameter : operation.getParameters()) {
					// J}
					if (!first) {
						out.print(", ");
					}

					// ^
//					out.print(parameter.getTypeExpression() + " ");
					out.print(JudeApi2CppUtil.getFullName(parameter.getType()) + " ");

					// O
					out.print(parameter.getName());

					first = false;
				}

			}

			out.print(")");

			// const֐
			if (isConst(operation)) {
				out.print(" const");
			}

			// z֐
			if (operation.isAbstract()) {
				out.print(" = 0");
			}

			out.println(";");

		}

		// ANZbT[̐錾
		createHeaderAccesser(out, iClass.getAttributes(), getParseTypeName(iClass));
		
		
		// NX錾̏I
		out.println("};");

		// CN[hK[hI
		out.println("#endif");
		out.close();
	}

	private void createHeaderAccesser(PrintWriter out, IAttribute[] attributes, String className) {

		if (!(JudeApi2CppProperty.getInstance().isCreateSetter() | JudeApi2CppProperty.getInstance().isCreateGetter())) {
			return;
		}

		if (attributes.length == 0) {
			return;
		}
		
		String indent = "    ";

		out.println();
		out.println("public: ");
		
		for (IAttribute attribute : attributes) {

			String upperCaseName = getUpperCaseName(attribute);
			if (upperCaseName.length() == 0) {
				continue;
			}

			// Zb^[
			if (JudeApi2CppProperty.getInstance().isCreateSetter()) {
				if (attribute.isChangeable()) {
					out.print(indent);
					// ÓI
					if (attribute.isStatic()) {
						out.print("static ");
					}
					out.print("void" + " ");
					out.print("set" + upperCaseName);
					out.print("(");
//					out.print(attribute.getTypeExpression() + " ");
					out.print(JudeApi2CppUtil.getFullName(attribute.getType()) + " ");
					out.print(attribute.getName());
					out.print(");");
					out.println();
				}
			}
			
			if (JudeApi2CppProperty.getInstance().isCreateGetter()) {
				// Qb^[
				out.print(indent);
//				out.print(attribute.getTypeExpression() + " ");
				out.print(JudeApi2CppUtil.getFullName(attribute.getType()) + " ");
				out.print("get" + upperCaseName);
				out.print("(");
				out.print(");");
				out.println();
				out.println();
			}
		}
	}

	private String getUpperCaseName(IAttribute attribute) {
		String name = (attribute.getName().length() != 0 ?  attribute.getName() : attribute.getAssociation().getName());
		if (name.length() == 0) {
			return "";
		}
		return name.substring(0, 1).toUpperCase() + (name.length() > 1 ? name.substring(1) : "");
	}

	public void printElementComment(PrintWriter out, String indent,
			INamedElement element) {
		
		if (element.getDefinition() == null || element.getDefinition().length() == 0) return;
		
		out.println();
		out.println(indent + "/**");
		out.println(indent
				+ " * "
				+ JudeApi2CppUtil.getDocumentCommentFormatDefinition(
						element.getDefinition(), indent));
		out.println(indent + " */");
	}

	/**
	 * NXcppt@C𐶐܂B
	 * 
	 * @param iClass
	 *            NX
	 * @throws IOException 
	 */
	private void createClassCppFile(IClass iClass) throws IOException {
		String name = getParseTypeName(iClass);
		PrintWriter out = createFile(name + ".cpp");
		if (out == null) {
			return;
		}

		// t@C̃Rg
		out.println("/*");
		out.println(" * " + name + ".cpp");
		out.println(" * " + "create date: "
				+ DateFormat.getDateInstance().format(new Date()));
		out.println(" */");

		// w肳ꂽ^̃CN[h
		for (String type : JudeApi2CppProperty.getInstance().getDefaultIncludeTypes()) {
			out.println("#include <" + type + ">");
		}

		// wb_[t@C̃CN[h
		out.println("#include \"" + name + ".h\"");

		// O std ̐錾
//		out.println("using namespace std;");

		// NX錾͂
		// Rg
		out.println();
		printElementComment(out, "", iClass);

		// lĂ郁o[ϐ̐錾(`)
		String indent = "";

		for (IAttribute attribute : iClass.getAttributes()) {

			if (attribute.isStatic() && !attribute.isChangeable()
					&& attribute.getInitialValue().length() > 0) {

				// static const ̂Ƃ́Al͐ݒ肵Ȃ
				if (attribute.isStatic() && !attribute.isChangeable()) {
					continue;
				}

				out.println();
				printElementComment(out, indent, attribute);

				out.print(indent);

				// 萔
				if (!attribute.isChangeable()) {
					out.print("const ");
				}

				// ^
//				out.print(attribute.getTypeExpression() + " ");
				out.print(JudeApi2CppUtil.getFullName(attribute.getType()) + " ");

				// ϐ
				out.print(name);
				out.print("::");
				out.print(attribute.getName());

				// dx
				if (JudeApi2CppUtil.isMultiplicity(attribute)) {
					out.print("[]");
				}

				// l
				if (attribute.getInitialValue().length() > 0) {
					out.print(" = " + attribute.getInitialValue());
				}

				out.println(";");
			}

		}

		// o[֐̐錾
		for (IOperation operation : iClass.getOperations()) {
			// z֐
			if (operation.isAbstract())
				continue;

			//@Rg
			out.println();
			printElementComment(out, indent, operation);

			out.print(indent);

			// inline
			if (isInline(operation)) {
				out.print("inline ");
			}

			// ߂ľ^
//			out.print(operation.getReturnTypeExpression() + " ");
			out.print(JudeApi2CppUtil.getFullName(operation.getReturnType()) + " ");

			// ֐
			if (!isFriend(operation)) {
				out.print(name);
				out.print("::");
			}
			out.print(operation.getName());
			out.print("(");

			// 
			if (operation.getParameters().length > 0) {
				boolean first = true;
				for (IParameter parameter : operation.getParameters()) {
					// J}
					if (!first) {
						out.print(", ");
					}

					// ^
//					out.print(parameter.getTypeExpression() + " ");
					out.print(JudeApi2CppUtil.getFullName(parameter.getType()) + " ");

					// O
					out.print(parameter.getName());

					first = false;
				}

			}

			out.print(")");

			// 萔
			if (isConst(operation)) {
				out.print(" const ");
			}

			// `
			out.println();
			out.println("{");

			// RXgN^EfXgN^EvoidȊÔƂ̓ftHg̖߂l߂
			if (!(operation.getReturnTypeExpression().equals("") || operation
					.getReturnTypeExpression().equals("void"))) {
				out.print("    return ");
				out.print(getReturnDefaultValue(operation));
				out.println(";");
			}

			out.println("}");
		}

		// ANZbT[̐錾
		createCppAccesser(out, iClass.getAttributes(), name);

		out.close();
	}

	private void createCppAccesser(PrintWriter out, IAttribute[] attributes, String className) {

		if (!(JudeApi2CppProperty.getInstance().isCreateSetter() | JudeApi2CppProperty.getInstance().isCreateGetter())) {
			return;
		}

		String indent = "";
		
		for (IAttribute attribute : attributes) {
			
			String upperCaseName = getUpperCaseName(attribute);
			if (upperCaseName.length() == 0) {
				continue;
			}

			// Zb^[
			if (JudeApi2CppProperty.getInstance().isCreateSetter()) {

				if (attribute.isChangeable()) {
					out.print(indent);
					out.print("void" + " ");
					out.print(className + "::");
					out.print("set" + upperCaseName);
					out.print("(");
//					out.print(attribute.getTypeExpression() + " ");
					out.print(JudeApi2CppUtil.getFullName(attribute.getType()) + " ");
					out.print(attribute.getName());
					out.print(")");
					out.println();
					out.println("{");
					out.println(indent
							+ "    "
							+ (attribute.isStatic() ? (className + "::")
									: "this->") + attribute.getName() + " = "
							+ attribute.getName() + ";");
					out.println("}");
					out.println();
				}
			}

			if (JudeApi2CppProperty.getInstance().isCreateGetter()) {
				// Qb^[
				out.print(indent);
//				out.print(attribute.getTypeExpression() + " ");
				out.print(JudeApi2CppUtil.getFullName(attribute.getType()) + " ");
				out.print(className + "::");
				out.print("get" + getUpperCaseName(attribute));
				out.print("(");
				out.print(")");
				out.println();
				out.println("{");
				out.println(indent + "    " + "return " + attribute.getName()
						+ ";");
				out.println("}");
				out.println();
			}
			
		}
		
	}

	/**
	 * ֐̖߂ľ^ɑΉftHg̖߂l擾B
	 * 
	 * @param operation
	 *            
	 * @return ftHg̖߂lB
	 */
	private String getReturnDefaultValue(IOperation operation) {
		final String[][] DEFAULT_VALUE = { { "char", "0" },
				{ "signed char", "0" }, { "unsigned char", "0" },
				{ "short", "0" }, { "signed short", "0" },
				{ "unsigned short", "0U" }, { "int", "0" },
				{ "signed int", "0" }, { "unsigned int", "0U" },
				{ "long", "0L" }, { "signed long", "0L" },
				{ "unsigned long", "0UL" }, { "float", "0.0F" },
				{ "double", "0.0" }, {"bool", "false" }, };

		for (int i = 0; i < DEFAULT_VALUE.length; i++) {
			if (DEFAULT_VALUE[i][0].equals(operation.getReturnTypeExpression())) {
				// if (operation.getReturnTypeExpression().replaceAll("\u0026",
				// "").trim().equals(DEFAULT_VALUE[i][0])) {
				return DEFAULT_VALUE[i][1];
			}
		}
		return "NULL";
	}

	// TODO ev[ǧ^擾B

	/**
	 * ^A|C^[QƂL擾B܂Aev[ǧ^ׂďB
	 * 
	 * @param type
	 *            NX
	 * @return NXA|C^[QƂL
	 */
	private String getParseTypeName(IClass type) {
		if (type == null)
			return null;

		String s = type.getName().replaceAll("[\u002a\u0026]", "").trim(); // [*&]
		int index = s.indexOf('<');

		return index < 0 ? s : s.substring(0, index);
	}

	/**
	 * ̃NX̒ŎgĂ^̏W擾B^̏W͈ȉ̂ƂB̒ŁAw肳ꂽO^͓ȂB E{NX Ě^
	 * E̖߂ľ^ Ë̌^
	 * 
	 * @param iClass
	 *            NX
	 * @return ̃NX̒ŎgĂ^̏W
	 */
	private Set<String> getParseTypeNames(IClass iClass) {
		if (iClass == null)
			return new HashSet<String>();

		Set<String> types = new HashSet<String>();

		// {NX
		IGeneralization[] generalizations = iClass.getGeneralizations();
		for (IGeneralization g : generalizations) {
			types.add(getParseTypeName(g.getSuperType()));
		}

		// ̌^
		for (IAttribute attribute : iClass.getAttributes()) {
			if (attribute.getName() == null || attribute.getName().isEmpty())
				continue;

			types.add(getParseTypeName(attribute.getType()));
		}

		// 
		for (IOperation operation : iClass.getOperations()) {
			// ߂ľ^
			types.add(getParseTypeName(operation.getReturnType()));

			// ̌^
			for (IParameter parameter : operation.getParameters()) {
				types.add(getParseTypeName(parameter.getType()));
			}
		}

		// O^
		types.removeAll(JudeApi2CppProperty.getInstance().getExceptTypes());
		types.remove(null);

		return types;
	}

	/**
	 * 킷擾܂B ́A3̂̂ꂩɁA킷 public, protected,
	 * private ƂłB ̕ȂꍇẢ public Ƃ܂B
	 * <p>
	 * <ul>
	 * <li>^OlƂ{ = true} 
	 * <li>XeI^Cv  
	 * <li>  
	 * </ul>
	 * </p>
	 * 
	 * @param element
	 *            Ovf
	 * @return 킷
	 */
	private String getVisibilityString(INamedElement element) {

		if (hasConstraint("protected", element)
				|| hasTaggedValue("protected", "true", element)
				|| hasStereotype("protected", element)) {
			return "protected";
		} else if (hasConstraint("private", element)
				|| hasTaggedValue("private", "true", element)
				|| hasStereotype("private", element)) {
			return "private";
		}

		return "public";
	}

	/**
	 * 삪Aconstł邩ǂ𔻒肵܂Bconstǂ́A3̂̂ꂩ藧ƂłB
	 * <p>
	 * <ul>
	 * <li>^OlƂ{const = true} 
	 * <li>XeI^Cv const 
	 * <li> const 
	 * </ul>
	 * </p>
	 * 
	 * @param operation
	 *            
	 * @return ̐錾ɁAconstantCqtrueB
	 */
	private boolean isConst(IOperation operation) {
		return hasConstraint("const", operation)
				|| hasTaggedValue("const", "true", operation)
				|| hasStereotype("const", operation);
	}

	/**
	 * 삪Aexplicitł邩ǂ𔻒肵܂Bexplicitǂ́A3̂̂ꂩ藧ƂłB
	 * <p>
	 * <ul>
	 * <li>^OlƂ{explicit = true} 
	 * <li>XeI^Cv explicit 
	 * <li> explicit 
	 * </ul>
	 * </p>
	 * 
	 * @param operation
	 *            
	 * @return ̐錾ɁAexplicitCqtrueB
	 */
	private boolean isExplicit(IOperation operation) {
		return hasConstraint("explicit", operation)
				|| hasTaggedValue("explicit", "true", operation)
				|| hasStereotype("explicit", operation);
	}

	/**
	 * 삪Ainlineł邩ǂ𔻒肵܂Binlineǂ́A3̂̂ꂩ藧ƂłB
	 * <p>
	 * <ul>
	 * <li>^OlƂ{inline = true} 
	 * <li>XeI^Cv inline 
	 * <li> inline 
	 * </ul>
	 * </p>
	 * 
	 * @param operation
	 *            
	 * @return ̐錾ɁAinlineCqtrueB
	 */
	private boolean isInline(IOperation operation) {
		return hasConstraint("inline", operation)
				|| hasTaggedValue("inline", "true", operation)
				|| hasStereotype("inline", operation);
	}

	/**
	 * 삪Afriendł邩ǂ𔻒肵܂Bfriendǂ́A3̂̂ꂩ藧ƂłB
	 * <p>
	 * <ul>
	 * <li>^OlƂ{friend = true} 
	 * <li>XeI^Cv friend 
	 * <li> friend 
	 * </ul>
	 * </p>
	 * 
	 * @param operation
	 *            
	 * @return ̐錾ɁAfriendCqtrueB
	 */
	private boolean isFriend(IOperation operation) {
		return hasConstraint("friend", operation)
				|| hasTaggedValue("friend", "true", operation)
				|| hasStereotype("friend", operation);
	}

	/**
	 * OvfAvirtualł邩ǂ𔻒肵܂Bvirtualǂ́A3̂̂ꂩ藧ƂłB
	 * <p>
	 * <ul>
	 * <li>^OlƂ{virtual = true} 
	 * <li>XeI^Cv virtual 
	 * <li> virtual 
	 * </ul>
	 * </p>
	 * 
	 * @param element
	 *            
	 * @return vfAvirtualłtrueB
	 */
	private boolean isVirtual(INamedElement element) {
		return hasConstraint("virtual", element)
				|| hasTaggedValue("virtual", "true", element)
				|| hasStereotype("virtual", element);
	}

	/**
	 * 삪Amutableł邩ǂ𔻒肵܂Bmutableǂ́A3̂̂ꂩ藧ƂłB
	 * <p>
	 * <ul>
	 * <li>^OlƂ{mutable = true} 
	 * <li>XeI^Cv mutable 
	 * <li> mutable 
	 * </ul>
	 * </p>
	 * 
	 * @param attribute
	 *            
	 * @return 삪AmutablełtrueB
	 */
	private boolean isMutable(IAttribute attribute) {
		return hasConstraint("mutable", attribute)
				|| hasTaggedValue("mutable", "true", attribute)
				|| hasStereotype("mutable", attribute);
	}

	/**
	 * ɁAw肳ꂽ񂪂邩ǂ𔻒肵܂B
	 * 
	 * @param keyword
	 *            
	 * @param element
	 *            
	 * @return ɁAw肳ꂽ񂪂trueB
	 */
	private boolean hasConstraint(String keyword, INamedElement element) {
		for (IConstraint constraint : element.getConstraints()) {
			if (constraint.getName().equals(keyword)) {
				return true;
			}
		}
		return false;
	}

	/**
	 * ^OlɁAw肳ꂽ^Ol邩ǂ𔻒肵܂B
	 * 
	 * @param keyword
	 *            ^ÕL[
	 * @param value
	 *            ^O̒l
	 * @param element
	 *            vf
	 * @return ^OlɁAw肳ꂽ^OltrueB
	 */
	private boolean hasTaggedValue(String keyword, String value,
			IElement element) {
		for (ITaggedValue taggedValue : element.getTaggedValues()) {
			if (taggedValue.getKey().equals(keyword)
					&& taggedValue.getValue().equals(value)) {
				return true;
			}
		}
		return false;
	}

	/**
	 * XeI^CvɁAw肳ꂽ񂪂邩ǂ𔻒肵܂B
	 * 
	 * @param keyword
	 *            
	 * @param element
	 *            vf
	 * @return vfɁAw肳ꂽ񂪂trueB
	 */
	private boolean hasStereotype(String keyword, IElement element) {
		for (String stereotype : element.getStereotypes()) {
			if (stereotype.equals(keyword)) {
				return true;
			}
		}
		return false;
	}

	/**
	 * w肳ꂽt@Cɏo͂Xg[𐶐܂B
	 * 
	 * @param name
	 *            t@C
	 * @return o̓Xg[BAt@CuȂꍇ null
	 * @throws IOException 
	 */
	private PrintWriter createFile(String name) throws IOException {
		String destinationName = destination.getPath() + File.separator + name;
		try {
			File destinationFile = new File(destinationName);
			if (!JudeApi2CppProperty.getInstance().isDeleteFiles() && !JudeApi2CppProperty.getInstance().isForceReplaceFile() && destinationFile.exists()) {
				if(!JudeApi2CppUtil.delete(destinationFile)) {
					System.out.println(destinationName + " t@C͍쐬܂łB");
					return null;
				}
			}
			System.out.println(destinationName + " t@C쐬܂B");
			return new PrintWriter(destinationName);
			
		} catch (IOException e) {
			e.printStackTrace();
			throw e;
		}
	}

}
